var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var _a, _b;
import { Editor, Node, mergeAttributes, InputRule, wrappingInputRule, isNodeActive, markInputRule, markPasteRule, Extension } from "@tiptap/core";
import { EditorContent, NodeViewWrapper, VueNodeViewRenderer, NodeViewContent } from "@tiptap/vue-2";
import Document from "@tiptap/extension-document";
import Paragraph from "@tiptap/extension-paragraph";
import Text from "@tiptap/extension-text";
import Blockquote from "@tiptap/extension-blockquote";
import OrderedList from "@tiptap/extension-ordered-list";
import ListItem from "@tiptap/extension-list-item";
import CodeBlock from "@tiptap/extension-code-block";
import HorizontalRule from "@tiptap/extension-horizontal-rule";
import Dropcursor from "@tiptap/extension-dropcursor";
import TipTapHardBreak from "@tiptap/extension-hard-break";
import { Table as Table$1 } from "@tiptap/extension-table";
import { TableCell as TableCell$1 } from "@tiptap/extension-table-cell";
import { TableHeader as TableHeader$1 } from "@tiptap/extension-table-header";
import { TableRow as TableRow$1 } from "@tiptap/extension-table-row";
import { TextSelection, Plugin, PluginKey } from "prosemirror-state";
import { isInTable, selectionCell, moveCellForward } from "prosemirror-tables";
import TiptapImage from "@tiptap/extension-image";
import { generateUrl } from "@nextcloud/router";
import ClickOutside from "vue-click-outside";
import Vue from "vue";
import Vuex, { Store } from "vuex";
import { getBuilder } from "@nextcloud/browser-storage";
import TipTapHeading from "@tiptap/extension-heading";
import TiptapBulletList from "@tiptap/extension-bullet-list";
import TiptapTaskList from "@tiptap/extension-task-list";
import TipTapTaskItem from "@tiptap/extension-task-item";
import { findParentNodeClosestToPos } from "prosemirror-utils";
import container from "markdown-it-container";
import TipTapItalic from "@tiptap/extension-italic";
import TipTapLink from "@tiptap/extension-link";
import MarkdownIt from "markdown-it";
import taskLists from "markdown-it-task-lists";
import TipTapStrike from "@tiptap/extension-strike";
import { Bold, starInputRegex, starPasteRegex, underscoreInputRegex, underscorePasteRegex } from "@tiptap/extension-bold";
import TipTapUnderline from "@tiptap/extension-underline";
var render$9 = function __render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.$editor ? _c("EditorContent", {
    attrs: {
      "id": "read-only-editor",
      "editor": _vm.$editor
    }
  }) : _vm._e();
};
var staticRenderFns$9 = [];
function normalizeComponent(scriptExports, render2, staticRenderFns2, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render2) {
    options.render = render2;
    options.staticRenderFns = staticRenderFns2;
    options._compiled = true;
  }
  if (functionalTemplate) {
    options.functional = true;
  }
  if (scopeId) {
    options._scopeId = "data-v-" + scopeId;
  }
  var hook;
  if (moduleIdentifier) {
    hook = function(context) {
      context = context || this.$vnode && this.$vnode.ssrContext || this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext;
      if (!context && typeof __VUE_SSR_CONTEXT__ !== "undefined") {
        context = __VUE_SSR_CONTEXT__;
      }
      if (injectStyles) {
        injectStyles.call(this, context);
      }
      if (context && context._registeredComponents) {
        context._registeredComponents.add(moduleIdentifier);
      }
    };
    options._ssrRegister = hook;
  } else if (injectStyles) {
    hook = shadowMode ? function() {
      injectStyles.call(this, (options.functional ? this.parent : this).$root.$options.shadowRoot);
    } : injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}
const __vue2_script$9 = {
  name: "BaseReader",
  components: { EditorContent },
  inject: ["renderHtml", "extensions"],
  props: {
    content: {
      type: String,
      required: true
    }
  },
  computed: {
    htmlContent() {
      return this.renderHtml(this.content);
    }
  },
  watch: {
    content() {
      this.updateContent();
    }
  },
  created() {
    this.$editor = this.createEditor();
    this.$editor.setOptions({ editable: false });
  },
  beforeDestroy() {
    this.$editor.destroy();
  },
  methods: {
    createEditor() {
      return new Editor({
        content: this.htmlContent,
        extensions: this.extensions
      });
    },
    updateContent() {
      this.$editor.commands.setContent(this.htmlContent);
    }
  }
};
const __cssModules$9 = {};
var __component__$9 = /* @__PURE__ */ normalizeComponent(__vue2_script$9, render$9, staticRenderFns$9, false, __vue2_injectStyles$9, null, null, null);
function __vue2_injectStyles$9(context) {
  for (let o in __cssModules$9) {
    this[o] = __cssModules$9[o];
  }
}
var BaseReader = /* @__PURE__ */ function() {
  return __component__$9.exports;
}();
/*
 * @copyright Copyright (c) 2022 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
const HardBreak = TipTapHardBreak.extend({
  toMarkdown(state, node, parent, index) {
    for (let i = index + 1; i < parent.childCount; i++) {
      if (parent.child(i).type !== node.type) {
        state.write("  \n");
        return;
      }
    }
  }
});
var TableCaption = Node.create({
  name: "tableCaption",
  content: "inline*",
  addAttributes() {
    return {};
  },
  renderHTML() {
    return ["caption"];
  },
  toMarkdown(state, node) {
  },
  parseHTML() {
    return [
      { tag: "table caption", priority: 90 }
    ];
  }
});
var TableCell = TableCell$1.extend({
  content: "inline*",
  toMarkdown(state, node) {
    state.write(" ");
    state.renderInline(node);
    state.write(" |");
  },
  parseHTML() {
    return [
      { tag: "td" },
      { tag: "th" },
      { tag: "table thead ~ tbody th", priority: 70 },
      { tag: "table thead ~ tbody td", priority: 70 }
    ];
  }
});
var TableHeader = TableHeader$1.extend({
  content: "inline*",
  toMarkdown(state, node) {
    state.write(" ");
    state.renderInline(node);
    state.write(" |");
  },
  parseHTML() {
    return [
      { tag: "table thead:empty ~ tbody :first-child th", priority: 80 },
      { tag: "table thead:empty ~ tbody :first-child td", priority: 80 },
      { tag: "table thead :first-child th", priority: 60 },
      { tag: "table thead :first-child td", priority: 60 },
      { tag: "table tbody :first-child th", priority: 60 },
      { tag: "table tbody :first-child td", priority: 60 },
      { tag: "table > :first-child > th", priority: 60 },
      { tag: "table > :first-child > td", priority: 60 }
    ];
  }
});
var TableRow = TableRow$1.extend({
  content: "tableCell*",
  toMarkdown(state, node) {
    state.write("|");
    state.renderInline(node);
    state.ensureNewLine();
  },
  parseHTML() {
    return [
      { tag: "tr", priority: 80 }
    ];
  }
});
var TableHeadRow = TableRow.extend({
  name: "tableHeadRow",
  content: "tableHeader*",
  toMarkdown(state, node) {
    state.write("|");
    state.renderInline(node);
    state.ensureNewLine();
    state.write("|");
    node.forEach((cell) => {
      state.write(state.repeat("-", cell.textContent.length + 2));
      state.write("|");
    });
    state.ensureNewLine();
  },
  parseHTML() {
    return [
      { tag: "tr", priority: 70 }
    ];
  }
});
function createTable(schema, rowsCount, colsCount, cellContent) {
  const headerCells = [];
  const cells = [];
  for (let index = 0; index < colsCount; index += 1) {
    const cell = schema.nodes.tableCell.createAndFill();
    if (cell) {
      cells.push(cell);
    }
    const headerCell = schema.nodes.tableHeader.createAndFill();
    if (headerCell) {
      headerCells.push(headerCell);
    }
  }
  const headRow = schema.nodes.tableHeadRow.createChecked(null, headerCells);
  const rows = [];
  for (let index = 1; index < rowsCount; index += 1) {
    rows.push(schema.nodes.tableRow.createChecked(null, cells));
  }
  return schema.nodes.table.createChecked(null, [headRow, ...rows]);
}
function findSameCellInNextRow($cell) {
  if ($cell.index(-1) === $cell.node(-1).childCount - 1) {
    return null;
  }
  let cellStart = $cell.after();
  const table = $cell.node(-1);
  for (let row = $cell.indexAfter(-1); row < table.childCount; row++) {
    const rowNode = table.child(row);
    if (rowNode.childCount >= $cell.index()) {
      for (let cell = 0; cell < $cell.index(); cell++) {
        const cellNode = rowNode.child(cell);
        cellStart += cellNode.nodeSize;
      }
      return cellStart + 1;
    }
    cellStart += rowNode.nodeSize;
  }
}
var Table = Table$1.extend({
  content: "tableCaption? tableHeadRow tableRow*",
  addExtensions() {
    return [
      TableCaption,
      TableCell,
      TableHeader,
      TableHeadRow,
      TableRow
    ];
  },
  addCommands() {
    return __spreadProps(__spreadValues({}, this.parent()), {
      insertTable: () => ({ tr, dispatch, editor }) => {
        if (isInTable(tr))
          return false;
        const node = createTable(editor.schema, 3, 3);
        if (dispatch) {
          const offset = tr.selection.anchor + 1;
          tr.replaceSelectionWith(node).scrollIntoView().setSelection(TextSelection.near(tr.doc.resolve(offset)));
        }
        return true;
      },
      leaveTable: () => ({ tr, dispatch, editor }) => {
        if (!isInTable(tr))
          return false;
        const { $head, empty } = tr.selection;
        if (!empty)
          return false;
        const tableDepth = $head.depth < 3 ? 1 : $head.depth - 2;
        if (dispatch) {
          const $next = tr.doc.resolve($head.after(tableDepth) + 1);
          const selection = TextSelection.near($next);
          dispatch(tr.setSelection(selection).scrollIntoView());
        }
        return true;
      },
      goToNextRow: () => ({ tr, dispatch, editor }) => {
        if (!isInTable(tr))
          return false;
        const cell = findSameCellInNextRow(selectionCell(tr));
        if (cell == null)
          return;
        if (dispatch) {
          const $cell = tr.doc.resolve(cell);
          const selection = TextSelection.between($cell, moveCellForward($cell));
          dispatch(tr.setSelection(selection).scrollIntoView());
        }
        return true;
      }
    });
  },
  renderHTML({ HTMLAttributes }) {
    return ["table", mergeAttributes(this.options.HTMLAttributes, HTMLAttributes), 0];
  },
  toMarkdown(state, node) {
    state.renderContent(node);
    state.closeBlock(node);
  },
  addKeyboardShortcuts() {
    return __spreadProps(__spreadValues({}, this.parent()), {
      Tab: () => this.editor.commands.goToNextCell() || this.editor.commands.leaveTable(),
      Enter: () => {
        if (this.editor.commands.goToNextRow()) {
          return true;
        }
        if (!this.editor.can().addRowAfter()) {
          return false;
        }
        return this.editor.chain().addRowAfter().goToNextRow().run();
      }
    });
  }
});
var render$8 = function __render__2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("span", _vm._b({
    staticClass: "material-design-icon alert-decagram-icon",
    attrs: {
      "aria-hidden": !_vm.title,
      "aria-label": _vm.title,
      "role": "img"
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, "span", _vm.$attrs, false), [_c("svg", {
    staticClass: "material-design-icon__svg",
    attrs: {
      "fill": _vm.fillColor,
      "width": _vm.size,
      "height": _vm.size,
      "viewBox": "0 0 24 24"
    }
  }, [_c("path", {
    attrs: {
      "d": "M23,12L20.56,9.22L20.9,5.54L17.29,4.72L15.4,1.54L12,3L8.6,1.54L6.71,4.72L3.1,5.53L3.44,9.21L1,12L3.44,14.78L3.1,18.47L6.71,19.29L8.6,22.47L12,21L15.4,22.46L17.29,19.28L20.9,18.46L20.56,14.78L23,12M13,17H11V15H13V17M13,13H11V7H13V13Z"
    }
  }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var staticRenderFns$8 = [];
const __vue2_script$8 = {
  name: "AlertDecagramIcon",
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
const __cssModules$8 = {};
var __component__$8 = /* @__PURE__ */ normalizeComponent(__vue2_script$8, render$8, staticRenderFns$8, false, __vue2_injectStyles$8, null, null, null);
function __vue2_injectStyles$8(context) {
  for (let o in __cssModules$8) {
    this[o] = __cssModules$8[o];
  }
}
var MDI_Danger = /* @__PURE__ */ function() {
  return __component__$8.exports;
}();
var render$7 = function __render__3() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("span", _vm._b({
    staticClass: "material-design-icon image-outline-icon",
    attrs: {
      "aria-hidden": !_vm.title,
      "aria-label": _vm.title,
      "role": "img"
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, "span", _vm.$attrs, false), [_c("svg", {
    staticClass: "material-design-icon__svg",
    attrs: {
      "fill": _vm.fillColor,
      "width": _vm.size,
      "height": _vm.size,
      "viewBox": "0 0 24 24"
    }
  }, [_c("path", {
    attrs: {
      "d": "M19,19H5V5H19M19,3H5A2,2 0 0,0 3,5V19A2,2 0 0,0 5,21H19A2,2 0 0,0 21,19V5A2,2 0 0,0 19,3M13.96,12.29L11.21,15.83L9.25,13.47L6.5,17H17.5L13.96,12.29Z"
    }
  }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var staticRenderFns$7 = [];
const __vue2_script$7 = {
  name: "ImageOutlineIcon",
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
const __cssModules$7 = {};
var __component__$7 = /* @__PURE__ */ normalizeComponent(__vue2_script$7, render$7, staticRenderFns$7, false, __vue2_injectStyles$7, null, null, null);
function __vue2_injectStyles$7(context) {
  for (let o in __cssModules$7) {
    this[o] = __cssModules$7[o];
  }
}
var MDI_Image = /* @__PURE__ */ function() {
  return __component__$7.exports;
}();
var render$6 = function __render__4() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("span", _vm._b({
    staticClass: "material-design-icon information-icon",
    attrs: {
      "aria-hidden": !_vm.title,
      "aria-label": _vm.title,
      "role": "img"
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, "span", _vm.$attrs, false), [_c("svg", {
    staticClass: "material-design-icon__svg",
    attrs: {
      "fill": _vm.fillColor,
      "width": _vm.size,
      "height": _vm.size,
      "viewBox": "0 0 24 24"
    }
  }, [_c("path", {
    attrs: {
      "d": "M13,9H11V7H13M13,17H11V11H13M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2Z"
    }
  }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var staticRenderFns$6 = [];
const __vue2_script$6 = {
  name: "InformationIcon",
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
const __cssModules$6 = {};
var __component__$6 = /* @__PURE__ */ normalizeComponent(__vue2_script$6, render$6, staticRenderFns$6, false, __vue2_injectStyles$6, null, null, null);
function __vue2_injectStyles$6(context) {
  for (let o in __cssModules$6) {
    this[o] = __cssModules$6[o];
  }
}
var MDI_Info = /* @__PURE__ */ function() {
  return __component__$6.exports;
}();
var render$5 = function __render__5() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("span", _vm._b({
    staticClass: "material-design-icon checkbox-marked-circle-icon",
    attrs: {
      "aria-hidden": !_vm.title,
      "aria-label": _vm.title,
      "role": "img"
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, "span", _vm.$attrs, false), [_c("svg", {
    staticClass: "material-design-icon__svg",
    attrs: {
      "fill": _vm.fillColor,
      "width": _vm.size,
      "height": _vm.size,
      "viewBox": "0 0 24 24"
    }
  }, [_c("path", {
    attrs: {
      "d": "M10,17L5,12L6.41,10.58L10,14.17L17.59,6.58L19,8M12,2A10,10 0 0,0 2,12A10,10 0 0,0 12,22A10,10 0 0,0 22,12A10,10 0 0,0 12,2Z"
    }
  }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var staticRenderFns$5 = [];
const __vue2_script$5 = {
  name: "CheckboxMarkedCircleIcon",
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
const __cssModules$5 = {};
var __component__$5 = /* @__PURE__ */ normalizeComponent(__vue2_script$5, render$5, staticRenderFns$5, false, __vue2_injectStyles$5, null, null, null);
function __vue2_injectStyles$5(context) {
  for (let o in __cssModules$5) {
    this[o] = __cssModules$5[o];
  }
}
var MDI_Positive = /* @__PURE__ */ function() {
  return __component__$5.exports;
}();
var render$4 = function __render__6() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("span", _vm._b({
    staticClass: "material-design-icon trash-can-icon",
    attrs: {
      "aria-hidden": !_vm.title,
      "aria-label": _vm.title,
      "role": "img"
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, "span", _vm.$attrs, false), [_c("svg", {
    staticClass: "material-design-icon__svg",
    attrs: {
      "fill": _vm.fillColor,
      "width": _vm.size,
      "height": _vm.size,
      "viewBox": "0 0 24 24"
    }
  }, [_c("path", {
    attrs: {
      "d": "M9,3V4H4V6H5V19A2,2 0 0,0 7,21H17A2,2 0 0,0 19,19V6H20V4H15V3H9M9,8H11V17H9V8M13,8H15V17H13V8Z"
    }
  }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var staticRenderFns$4 = [];
const __vue2_script$4 = {
  name: "TrashCanIcon",
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
const __cssModules$4 = {};
var __component__$4 = /* @__PURE__ */ normalizeComponent(__vue2_script$4, render$4, staticRenderFns$4, false, __vue2_injectStyles$4, null, null, null);
function __vue2_injectStyles$4(context) {
  for (let o in __cssModules$4) {
    this[o] = __cssModules$4[o];
  }
}
var MDI_TrashCan = /* @__PURE__ */ function() {
  return __component__$4.exports;
}();
var render$3 = function __render__7() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("span", _vm._b({
    staticClass: "material-design-icon alert-icon",
    attrs: {
      "aria-hidden": !_vm.title,
      "aria-label": _vm.title,
      "role": "img"
    },
    on: {
      "click": function click($event) {
        return _vm.$emit("click", $event);
      }
    }
  }, "span", _vm.$attrs, false), [_c("svg", {
    staticClass: "material-design-icon__svg",
    attrs: {
      "fill": _vm.fillColor,
      "width": _vm.size,
      "height": _vm.size,
      "viewBox": "0 0 24 24"
    }
  }, [_c("path", {
    attrs: {
      "d": "M13 14H11V9H13M13 18H11V16H13M1 21H23L12 2L1 21Z"
    }
  }, [_vm.title ? _c("title", [_vm._v(_vm._s(_vm.title))]) : _vm._e()])])]);
};
var staticRenderFns$3 = [];
const __vue2_script$3 = {
  name: "AlertIcon",
  props: {
    title: {
      type: String
    },
    fillColor: {
      type: String,
      default: "currentColor"
    },
    size: {
      type: Number,
      default: 24
    }
  }
};
const __cssModules$3 = {};
var __component__$3 = /* @__PURE__ */ normalizeComponent(__vue2_script$3, render$3, staticRenderFns$3, false, __vue2_injectStyles$3, null, null, null);
function __vue2_injectStyles$3(context) {
  for (let o in __cssModules$3) {
    this[o] = __cssModules$3[o];
  }
}
var MDI_Warn = /* @__PURE__ */ function() {
  return __component__$3.exports;
}();
const DEFAULT_ICON_SIZE = 20;
const makeIcon = (original) => ({
  functional: true,
  render(h, { data, props }) {
    return h(original, {
      data,
      key: data.key,
      staticClass: data.staticClass,
      props: __spreadValues({ size: DEFAULT_ICON_SIZE }, props)
    });
  }
});
const Danger = makeIcon(MDI_Danger);
const Image$2 = makeIcon(MDI_Image);
const Info = makeIcon(MDI_Info);
const Positive = makeIcon(MDI_Positive);
const TrashCan = makeIcon(MDI_TrashCan);
const Warn = makeIcon(MDI_Warn);
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const persistentStorage = getBuilder("text").persist().build();
Vue.use(Vuex);
const store$1 = new Store({
  state: {
    showAuthorAnnotations: persistentStorage.getItem("showAuthorAnnotations") === "true",
    currentSession: persistentStorage.getItem("currentSession")
  },
  mutations: {
    SET_SHOW_AUTHOR_ANNOTATIONS(state, value) {
      state.showAuthorAnnotations = value;
      persistentStorage.setItem("showAuthorAnnotations", "" + value);
    },
    SET_CURRENT_SESSION(state, value) {
      state.currentSession = value;
      persistentStorage.setItem("currentSession", value);
    }
  },
  actions: {
    setShowAuthorAnnotations({ commit }, value) {
      store$1.commit("SET_SHOW_AUTHOR_ANNOTATIONS", value);
    },
    setCurrentSession({ commit }, value) {
      store$1.commit("SET_CURRENT_SESSION", value);
    }
  }
});
/*
 * @copyright Copyright (c) 2021 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
var store = {
  data() {
    return {
      $store: store$1
    };
  },
  beforeMount() {
    if (typeof this.$store === "undefined") {
      this.$store = store$1;
    }
  }
};
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const IMAGE_RESOLVER = Symbol("image:resolver");
const useImageResolver = {
  inject: {
    $imageResolver: {
      from: IMAGE_RESOLVER,
      default: {
        resolve(src) {
          console.warn("No image resolver provided. Some image sources cannot be resolved.");
          return [src];
        }
      }
    }
  }
};
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const mimetypesImages = [
  "image/png",
  "image/jpeg",
  "image/jpg",
  "image/gif",
  "image/x-xbitmap",
  "image/x-ms-bmp",
  "image/bmp",
  "image/svg+xml",
  "image/webp"
];
if (!((_a = window.oc_appswebroots) == null ? void 0 : _a.richdocuments) && !((_b = window.oc_appswebroots) == null ? void 0 : _b.onlyoffice))
  ;
var render$2 = function __render__8() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("NodeViewWrapper", [_c("div", {
    staticClass: "image image-view",
    class: {
      "icon-loading": !_vm.loaded,
      "image-view--failed": _vm.failed
    },
    attrs: {
      "data-component": "image-view",
      "data-src": _vm.src
    }
  }, [_vm.canDisplayImage ? _c("div", {
    directives: [{
      name: "click-outside",
      rawName: "v-click-outside",
      value: function value() {
        return _vm.showIcons = false;
      },
      expression: "() => showIcons = false"
    }],
    staticClass: "image__view",
    on: {
      "click": function click($event) {
        _vm.showIcons = true;
      },
      "mouseover": function mouseover($event) {
        _vm.showIcons = true;
      },
      "mouseleave": function mouseleave($event) {
        _vm.showIcons = false;
      }
    }
  }, [_c("transition", {
    attrs: {
      "name": "fade"
    }
  }, [!_vm.failed ? [_c("img", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.loaded,
      expression: "loaded"
    }],
    staticClass: "image__main",
    attrs: {
      "src": _vm.imageUrl
    },
    on: {
      "load": _vm.onLoaded
    }
  })] : [_c("ImageIcon", {
    staticClass: "image__main image__main--broken-icon",
    attrs: {
      "size": 100
    }
  })]], 2), _c("transition", {
    attrs: {
      "name": "fade"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.loaded,
      expression: "loaded"
    }],
    staticClass: "image__caption"
  }, [_c("input", {
    ref: "altInput",
    staticClass: "image__caption__input",
    attrs: {
      "type": "text"
    },
    domProps: {
      "value": _vm.alt
    },
    on: {
      "keyup": function keyup($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return _vm.updateAlt.apply(null, arguments);
      }
    }
  }), _vm.editor.isEditable && _vm.showIcons ? _c("div", {
    staticClass: "image__caption__delete",
    attrs: {
      "title": "Delete this image"
    },
    on: {
      "click": _vm.deleteNode
    }
  }, [_c("TrashCan")], 1) : _vm._e()])])], 1) : _c("div", {
    staticClass: "image-view__cant_display"
  }, [_c("transition", {
    attrs: {
      "name": "fade"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.loaded,
      expression: "loaded"
    }]
  }, [_c("a", {
    attrs: {
      "href": _vm.internalLinkOrImage,
      "target": "_blank"
    }
  }, [!_vm.isSupportedImage ? _c("span", [_vm._v(_vm._s(_vm.alt))]) : _vm._e()])])]), _vm.isSupportedImage ? _c("transition", {
    attrs: {
      "name": "fade"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.loaded,
      expression: "loaded"
    }],
    staticClass: "image__caption"
  }, [_c("input", {
    ref: "altInput",
    attrs: {
      "type": "text"
    },
    domProps: {
      "value": _vm.alt
    },
    on: {
      "keyup": function keyup($event) {
        if (!$event.type.indexOf("key") && _vm._k($event.keyCode, "enter", 13, $event.key, "Enter"))
          return null;
        return _vm.updateAlt();
      }
    }
  })])]) : _vm._e()], 1), _vm.errorMessage ? _c("small", {
    staticClass: "image__error-message"
  }, [_vm._v(" " + _vm._s(_vm.errorMessage) + " ")]) : _vm._e()])]);
};
var staticRenderFns$2 = [];
var ImageView_vue_vue_type_style_index_0_scoped_true_lang = /* @__PURE__ */ (() => ".image[data-v-89cc90ae] {\n  margin: 0;\n  padding: 0;\n}\n.image__caption[data-v-89cc90ae] {\n  text-align: center;\n  color: var(--color-text-lighter);\n  display: flex;\n  align-items: center;\n  justify-content: center;\n}\n.image__caption input[type=text][data-v-89cc90ae] {\n  max-width: 80%;\n  border: none;\n  text-align: center;\n  background-color: transparent;\n}\n.image__loading[data-v-89cc90ae] {\n  height: 100px;\n}\n.image__main--broken-icon[data-v-89cc90ae], .image__error-message[data-v-89cc90ae] {\n  color: var(--color-text-maxcontrast);\n}\n.image__view[data-v-89cc90ae] {\n  text-align: center;\n  position: relative;\n}\n.image__view img[data-v-89cc90ae] {\n  max-width: 100%;\n}\n.image__main[data-v-89cc90ae] {\n  max-height: calc(100vh - 50px - 50px);\n}\n.image__error-message[data-v-89cc90ae] {\n  display: block;\n  text-align: center;\n}\n.fade-enter-active[data-v-89cc90ae] {\n  transition: opacity 0.3s ease-in-out;\n}\n.fade-enter-to[data-v-89cc90ae] {\n  opacity: 1;\n}\n.fade-enter[data-v-89cc90ae] {\n  opacity: 0;\n}\n.image__caption__delete[data-v-89cc90ae] {\n  position: absolute;\n  right: 0;\n  display: flex;\n  justify-content: flex-end;\n  align-items: center;\n  width: 20px;\n  height: 20px;\n}\n.image__caption__delete[data-v-89cc90ae], .image__caption__delete svg[data-v-89cc90ae] {\n  cursor: pointer;\n}")();
const getQueryVariable = (src, variable) => {
  const query = src.split("?")[1];
  if (typeof query === "undefined") {
    return;
  }
  const vars = query.split(/[&#]/);
  if (typeof vars === "undefined") {
    return;
  }
  for (let i = 0; i < vars.length; i++) {
    const pair = vars[i].split("=");
    if (decodeURIComponent(pair[0]) === variable) {
      return decodeURIComponent(pair[1]);
    }
  }
};
class LoadImageError extends Error {
  constructor(reason, imageUrl) {
    super((reason == null ? void 0 : reason.message) || t("text", "Failed to load"));
    this.reason = reason;
    this.imageUrl = imageUrl;
  }
}
const __vue2_script$2 = {
  name: "ImageView",
  components: {
    ImageIcon: Image$2,
    TrashCan,
    NodeViewWrapper
  },
  directives: {
    ClickOutside
  },
  mixins: [
    store,
    useImageResolver
  ],
  props: ["editor", "node", "extension", "updateAttributes", "deleteNode"],
  data() {
    return {
      imageLoaded: false,
      loaded: false,
      failed: false,
      showIcons: false,
      imageUrl: null,
      errorMessage: null
    };
  },
  computed: {
    canDisplayImage() {
      if (!this.isSupportedImage) {
        return false;
      }
      if (this.failed && this.loaded) {
        return true;
      }
      return this.loaded && this.imageLoaded;
    },
    imageFileId() {
      return getQueryVariable(this.src, "fileId");
    },
    isSupportedImage() {
      return typeof this.mime === "undefined" || mimetypesImages.indexOf(this.mime) !== -1;
    },
    internalLinkOrImage() {
      if (this.imageFileId) {
        return generateUrl("/f/" + this.imageFileId);
      }
      return this.src;
    },
    src: {
      get() {
        return this.node.attrs.src || "";
      },
      set(src) {
        this.updateAttributes({
          src
        });
      }
    },
    alt: {
      get() {
        return this.node.attrs.alt ? this.node.attrs.alt : "";
      },
      set(alt) {
        this.updateAttributes({
          alt
        });
      }
    },
    t() {
      return (a, s) => window.t(a, s);
    },
    token() {
      return document.getElementById("sharingToken") && document.getElementById("sharingToken").value;
    }
  },
  beforeMount() {
    if (!this.isSupportedImage) {
      this.failed = true;
      this.imageLoaded = false;
      this.loaded = true;
      this.errorMessage = t("text", "Unsuported image");
      return;
    }
    this.init().catch(this.onImageLoadFailure);
  },
  methods: {
    async init() {
      const [url, fallback] = this.$imageResolver.resolve(this.src);
      return this.loadImage(url).catch((e) => {
        if (fallback) {
          return this.loadImage(fallback);
        }
        return Promise.reject(e);
      });
    },
    async loadImage(imageUrl) {
      return new Promise((resolve, reject) => {
        const img = new Image();
        img.onload = () => {
          this.imageUrl = imageUrl;
          this.imageLoaded = true;
          this.loaded = true;
          resolve(imageUrl);
        };
        img.onerror = (e) => {
          reject(new LoadImageError(e, imageUrl));
        };
        img.src = imageUrl;
      });
    },
    onImageLoadFailure(err) {
      this.failed = true;
      this.imageLoaded = false;
      this.loaded = true;
      this.errorMessage = err.message;
      if (err instanceof LoadImageError) {
        this.errorMessage = `${this.errorMessage} ${this.src}`;
      }
      this.$emit("error", { error: err, src: this.src });
    },
    updateAlt(event) {
      this.updateAttributes({
        alt: event.target.value
      });
    },
    onLoaded() {
      this.loaded = true;
      this.$nextTick(() => {
        this.editor.commands.scrollIntoView();
      });
    }
  }
};
const __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$2, staticRenderFns$2, false, __vue2_injectStyles$2, "89cc90ae", null, null);
function __vue2_injectStyles$2(context) {
  for (let o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var ImageView = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Image$1 = TiptapImage.extend({
  selectable: false,
  addOptions() {
    var _a2;
    return __spreadValues({}, (_a2 = this.parent) == null ? void 0 : _a2.call(this));
  },
  addNodeView() {
    return VueNodeViewRenderer(ImageView);
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleDrop: (view, event, slice) => {
            if (event.dataTransfer.files && event.dataTransfer.files.length > 0) {
              const coordinates = view.posAtCoords({ left: event.clientX, top: event.clientY });
              const customEvent = new CustomEvent("image-drop", {
                bubbles: true,
                detail: {
                  files: event.dataTransfer.files,
                  position: coordinates.pos
                }
              });
              event.target.dispatchEvent(customEvent);
              return true;
            }
          },
          handlePaste: (view, event, slice) => {
            if (event.clipboardData.files && event.clipboardData.files.length > 0) {
              const customEvent = new CustomEvent("image-paste", {
                bubbles: true,
                detail: {
                  files: event.clipboardData.files
                }
              });
              event.target.dispatchEvent(customEvent);
              return true;
            }
          }
        }
      })
    ];
  }
});
const Heading = TipTapHeading.extend({
  addKeyboardShortcuts() {
    return this.options.levels.reduce((items, level) => __spreadProps(__spreadValues({}, items), {
      [`Mod-Shift-${level}`]: () => this.editor.commands.toggleHeading({ level })
    }), {});
  }
});
/*
 * @copyright Copyright (c) 2021 Jonas Meurer <jonas@freesources.org>
 *
 * @author Jonas Meurer <jonas@freesources.org>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function listInputRule(find, type, getAttributes) {
  const handler = ({ state, range, match }) => {
    const wrap = wrappingInputRule({ find, type, getAttributes });
    wrap.handler({ state, range, match });
    if (match.length >= 3) {
      state.tr.insertText(match[2]);
    }
  };
  return new InputRule({ find, handler });
}
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const BulletList = TiptapBulletList.extend({
  addInputRules() {
    return [
      listInputRule(/^\s*([-+*])\s([^\s[])$/, this.type)
    ];
  }
});
/*
 * @copyright Copyright (c) 2020 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const TaskList = TiptapTaskList.extend({
  parseHTML: [
    {
      priority: 100,
      tag: "ul.contains-task-list"
    }
  ],
  toMarkdown: (state, node) => {
    state.renderList(node, "  ", () => (node.attrs.bullet || "*") + " ");
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const TaskItem = TipTapTaskItem.extend({
  addOptions() {
    return {
      nested: true,
      HTMLAttributes: {}
    };
  },
  draggable: false,
  content: "paragraph block*",
  addAttributes() {
    const adjust = __spreadValues({}, this.parent());
    adjust.checked.parseHTML = (el) => {
      var _a2;
      return (_a2 = el.querySelector("input[type=checkbox]")) == null ? void 0 : _a2.checked;
    };
    return adjust;
  },
  parseHTML: [
    {
      priority: 101,
      tag: "li",
      getAttrs: (el) => {
        const checkbox = el.querySelector("input[type=checkbox]");
        return checkbox;
      },
      context: "taskList/"
    }
  ],
  renderHTML({ node, HTMLAttributes }) {
    const listAttributes = { class: "checkbox-item" };
    const checkboxAttributes = { type: "checkbox", class: "", contenteditable: false };
    if (node.attrs.checked) {
      checkboxAttributes.checked = true;
      listAttributes.class += " checked";
    }
    return [
      "li",
      mergeAttributes(HTMLAttributes, listAttributes),
      [
        "input",
        checkboxAttributes
      ],
      [
        "label",
        0
      ]
    ];
  },
  addNodeView: false,
  toMarkdown: (state, node) => {
    state.write(`[${node.attrs.checked ? "x" : " "}] `);
    state.renderContent(node);
  },
  addInputRules() {
    return [
      ...this.parent(),
      wrappingInputRule({
        find: /^\s*([-+*])\s(\[(x|X| ?)\])\s$/,
        type: this.type,
        getAttributes: (match) => ({
          checked: "xX".includes(match[match.length - 1])
        })
      })
    ];
  },
  addProseMirrorPlugins() {
    return [
      new Plugin({
        props: {
          handleClick: (view, pos, event) => {
            const state = view.state;
            const schema = state.schema;
            const coordinates = view.posAtCoords({ left: event.clientX, top: event.clientY });
            const position = state.doc.resolve(coordinates.pos);
            const parentList = findParentNodeClosestToPos(position, function(node) {
              return node.type === schema.nodes.taskItem || node.type === schema.nodes.listItem;
            });
            const isListClicked = event.target.tagName.toLowerCase() === "li";
            if (!isListClicked || !parentList || parentList.node.type !== schema.nodes.taskItem) {
              return;
            }
            const tr = state.tr;
            tr.setNodeMarkup(parentList.pos, schema.nodes.taskItem, { checked: !parentList.node.attrs.checked });
            view.dispatch(tr);
          }
        }
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const typesAvailable = ["info", "warn", "error", "success"];
const buildRender = (type) => (tokens, idx, options, env, slf) => {
  const tag = tokens[idx];
  if (tag.nesting === 1) {
    tag.attrSet("data-callout", type);
    tag.attrJoin("class", `callout callout-${type}`);
  }
  return slf.renderToken(tokens, idx, options, env, slf);
};
var callouts = (md) => {
  typesAvailable.forEach((type) => {
    md.use(container, type, {
      render: buildRender(type)
    });
  });
  return md;
};
var render$1 = function __render__9() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("NodeViewWrapper", {
    staticClass: "callout",
    class: "callout--".concat(_vm.type),
    attrs: {
      "data-text-el": "callout",
      "as": "div"
    }
  }, [_c(_vm.icon, {
    tag: "component",
    staticClass: "callout__icon"
  }), _c("NodeViewContent", {
    staticClass: "callout__content"
  })], 1);
};
var staticRenderFns$1 = [];
var Callout_vue_vue_type_style_index_0_scoped_true_lang = /* @__PURE__ */ (() => ".callout[data-v-44a110bb] {\n  background-color: var(--callout-background, var(--color-background-hover));\n  border-left-color: var(--callout-border, var(--color-primary-element));\n  border-radius: var(--border-radius);\n  padding: 1em;\n  padding-left: 0.5em;\n  border-left-width: 0.3em;\n  border-left-style: solid;\n  position: relative;\n  margin-bottom: 0.5em;\n  display: flex;\n  align-items: center;\n  justify-content: flex-start;\n}\n+ .callout[data-v-44a110bb] {\n  margin-top: 0.5em;\n}\n.callout .callout__content[data-v-44a110bb] {\n  margin-left: 1em;\n}\n.callout .callout__content[data-v-44a110bb] p:last-child {\n  margin-bottom: 0;\n}\n.callout .callout__icon[data-v-44a110bb], .callout .callout__icon[data-v-44a110bb]  svg {\n  color: var(--callout-border);\n}\n.callout[data-v-44a110bb], .callout--info[data-v-44a110bb] {\n  --callout-border: var(--color-primary-element);\n}\n.callout--warn[data-v-44a110bb] {\n  --callout-border: var(--color-warning);\n}\n.callout--error[data-v-44a110bb] {\n  --callout-border: var(--color-error);\n}\n.callout--success[data-v-44a110bb] {\n  --callout-border: var(--color-success);\n}")();
const ICONS_MAP = {
  info: Info,
  success: Positive,
  error: Danger,
  warn: Warn
};
const __vue2_script$1 = {
  name: "Callout",
  components: {
    NodeViewWrapper,
    NodeViewContent
  },
  props: {
    node: {
      type: Object,
      required: true
    }
  },
  computed: {
    icon() {
      return ICONS_MAP[this.type] || Info;
    },
    type() {
      var _a2, _b2;
      return ((_b2 = (_a2 = this.node) == null ? void 0 : _a2.attrs) == null ? void 0 : _b2.type) || "info";
    }
  }
};
const __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render$1, staticRenderFns$1, false, __vue2_injectStyles$1, "44a110bb", null, null);
function __vue2_injectStyles$1(context) {
  for (let o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var Callout$1 = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
/*
 * @copyright Copyright (c) 2022 Vinicius Reis <vinicius@nextcloud.com>
 *
 * @author Vinicius Reis <vinicius@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
var Callout = Node.create({
  name: "callout",
  content: "paragraph+",
  group: "block",
  defining: true,
  addOptions() {
    return {
      types: typesAvailable,
      HTMLAttributes: {
        class: "callout"
      }
    };
  },
  addAttributes() {
    return {
      type: {
        default: "info",
        rendered: false,
        parseHTML: (element) => {
          return element.getAttribute("data-callout") || typesAvailable.find((type) => element.classList.contains(type)) || element.classList.contains("warning") && "warn";
        },
        renderHTML: (attributes) => {
          return {
            "data-callout": attributes.type,
            class: `callout-${attributes.type}`
          };
        }
      }
    };
  },
  parseHTML() {
    return [
      {
        tag: "div.callout"
      },
      {
        tag: "p.callout",
        priority: 1001
      }
    ];
  },
  renderHTML({ node, HTMLAttributes }) {
    const { class: classy } = this.options.HTMLAttributes;
    const attributes = __spreadProps(__spreadValues({}, this.options.HTMLAttributes), {
      "data-callout": node.attrs.type,
      class: `${classy} ${classy}-${node.attrs.type}`
    });
    return ["div", mergeAttributes(attributes, HTMLAttributes), 0];
  },
  toMarkdown: (state, node) => {
    state.write("::: " + (node.attrs.type || "info") + "\n");
    state.renderContent(node);
    state.ensureNewLine();
    state.write(":::");
    state.closeBlock(node);
  },
  addNodeView() {
    return VueNodeViewRenderer(Callout$1);
  },
  addCommands() {
    return {
      setCallout: (attributes) => ({ commands }) => {
        return commands.wrapIn(this.name, attributes);
      },
      toggleCallout: (attributes) => ({ commands, state }) => {
        if (!isNodeActive(state, this.name)) {
          return commands.setCallout(attributes);
        }
        if (!isNodeActive(state, this.name, attributes)) {
          return commands.updateAttributes(this.name, attributes);
        }
        return commands.unsetCallout();
      },
      unsetCallout: () => ({ commands }) => {
        return commands.lift(this.name);
      }
    };
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function markdownUnderlines(md) {
  md.inline.ruler2.after("emphasis", "underline", (state) => {
    const tokens = state.tokens;
    for (let i = tokens.length - 1; i > 0; i--) {
      const token = tokens[i];
      if (token.markup === "__") {
        if (token.type === "strong_open") {
          tokens[i].tag = "u";
          tokens[i].type = "u_open";
        }
        if (token.type === "strong_close") {
          tokens[i].tag = "u";
          tokens[i].type = "u_close";
        }
      }
    }
    return false;
  });
}
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
function splitMixedLists(md) {
  md.core.ruler.after("github-task-lists", "split-mixed-task-lists", (state) => {
    const tokens = state.tokens;
    for (let i = 0; i < tokens.length; i++) {
      const token = tokens[i];
      if (token.attrGet("class") !== "contains-task-list") {
        continue;
      }
      const firstChild = tokens[i + 1];
      const startsWithTask = firstChild.attrGet("class") === "task-list-item";
      if (!startsWithTask) {
        token.attrs.splice(token.attrIndex("class"));
        if (token.attrs.length === 0) {
          token.attrs = null;
        }
      }
      const splitBefore = findChildOf(tokens, i, (child) => {
        return child.nesting === 1 && child.attrGet("class") !== firstChild.attrGet("class");
      });
      if (splitBefore > i) {
        splitListAt(tokens, splitBefore, state.Token);
      }
    }
    return false;
  });
}
function splitListAt(tokens, index, TokenConstructor) {
  const closeList = new TokenConstructor("bullet_list_close", "ul", -1);
  closeList.block = true;
  const openList = new TokenConstructor("bullet_list_open", "ul", 1);
  openList.attrSet("class", "contains-task-list");
  openList.block = true;
  tokens.splice(index, 0, closeList, openList);
}
function findChildOf(tokens, parentIndex, predicate) {
  const searchLevel = tokens[parentIndex].level + 1;
  for (let i = parentIndex + 1; i < tokens.length; i++) {
    const token = tokens[i];
    if (token.level < searchLevel) {
      return -1;
    }
    if (token.level === searchLevel && predicate(tokens[i])) {
      return i;
    }
  }
  return -1;
}
const markdownit = MarkdownIt("commonmark", { html: false, breaks: false }).enable("strikethrough").enable("table").use(taskLists, { enable: true, labelAfter: true }).use(splitMixedLists).use(markdownUnderlines).use(callouts);
/*
 * @copyright Copyright (c) 2020 Azul <azul@riseup.net>
 *
 * @author Azul <azul@riseup.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const absolutePath = function(base, rel) {
  if (!rel) {
    return base;
  }
  if (rel[0] === "/") {
    return rel;
  }
  base = base.split("/");
  rel = rel.split("/");
  while (rel[0] === ".." || rel[0] === ".") {
    if (rel[0] === "..") {
      base.pop();
    }
    rel.shift();
  }
  return base.concat(rel).join("/");
};
const basedir = function(file) {
  const end = file.lastIndexOf("/");
  return end > 0 ? file.slice(0, end) : file.slice(0, end + 1);
};
const domHref = function(node) {
  const ref = node.attrs.href;
  if (!ref) {
    return ref;
  }
  if (ref.match(/^[a-zA-Z]*:/)) {
    return ref;
  }
  const match = ref.match(/^([^?]*)\?fileId=(\d+)/);
  if (match) {
    const [, relPath, id] = match;
    const currentDir = basedir(OCA.Viewer.file);
    const dir = absolutePath(currentDir, basedir(relPath));
    return generateUrl(`/apps/files/?dir=${dir}&openfile=${id}#relPath=${relPath}`);
  }
};
const parseHref = function(dom) {
  const ref = dom.getAttribute("href");
  if (!ref) {
    return ref;
  }
  const match = ref.match(/\?dir=([^&]*)&openfile=([^&]*)#relPath=([^&]*)/);
  if (match) {
    const [, , id, path] = match;
    return `${path}?fileId=${id}`;
  }
  return ref;
};
const openLink = function(event, _attrs) {
  const linkElement = event.target.closest("a");
  event.stopPropagation();
  const htmlHref = linkElement.href;
  if (event.button === 0 && !event.ctrlKey && htmlHref.startsWith(window.location.origin)) {
    const query = OC.parseQueryString(htmlHref);
    const fragment = OC.parseQueryString(htmlHref.split("#").pop());
    if (query.dir && fragment.relPath) {
      const filename = fragment.relPath.split("/").pop();
      const path = `${query.dir}/${filename}`;
      document.title = `${filename} - ${OC.theme.title}`;
      if (window.location.pathname.match(/apps\/files\/$/))
        ;
      OCA.Viewer.open({ path });
      return;
    }
    if (query.fileId) {
      window.open(generateUrl(`/f/${query.fileId}`));
      return;
    }
  }
  if (!markdownit.validateLink(htmlHref)) {
    console.error("Invalid link", htmlHref);
    return false;
  }
  window.open(htmlHref);
  return true;
};
const clickHandler = ({ editor, type, onClick }) => {
  return new Plugin({
    props: {
      key: new PluginKey("textLink"),
      handleClick: (view, pos, event) => {
        const $clicked = view.state.doc.resolve(pos);
        const link = $clicked.marks().find((m) => m.type.name === type.name);
        if (!link) {
          return false;
        }
        if (!link.attrs.href) {
          console.warn("Could not determine href of link.");
          console.debug(link);
          return false;
        }
        return onClick == null ? void 0 : onClick(event, link.attrs);
      }
    }
  });
};
/*
 * @copyright Copyright (c) 2019 Azul <azul@riseup.net>
 *
 * @author Azul <azul@riseup.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Link = TipTapLink.extend({
  addOptions() {
    var _a2;
    return __spreadProps(__spreadValues({}, (_a2 = this.parent) == null ? void 0 : _a2.call(this)), {
      onClick: openLink
    });
  },
  addAttributes() {
    return {
      href: {
        default: null
      }
    };
  },
  inclusive: false,
  parseHTML: [
    {
      tag: "a[href]",
      getAttrs: (dom) => ({
        href: parseHref(dom)
      })
    }
  ],
  renderHTML: ({ mark, HTMLAttributes }) => ["a", __spreadProps(__spreadValues({}, mark.attrs), {
    href: domHref(mark),
    title: mark.attrs.href,
    rel: "noopener noreferrer nofollow"
  }), 0],
  addProseMirrorPlugins() {
    const plugins = this.parent().filter(({ key }) => {
      return !key.startsWith("handleClickLink");
    });
    if (!this.options.openOnClick) {
      return plugins;
    }
    return [
      ...plugins,
      clickHandler({
        editor: this.editor,
        type: this.type,
        onClick: this.options.onClick
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
var Strike = TipTapStrike.extend({
  parseHTML() {
    return [
      {
        tag: "s"
      },
      {
        tag: "del"
      },
      {
        tag: "strike"
      },
      {
        style: "text-decoration",
        getAttrs: (value) => value === "line-through"
      }
    ];
  },
  renderHTML() {
    return ["s", 0];
  },
  toMarkdown: {
    open: "~~",
    close: "~~",
    mixable: true,
    expelEnclosingWhitespace: true
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Strong = Bold.extend({
  name: "strong",
  addInputRules() {
    return [
      markInputRule({
        find: starInputRegex,
        type: this.type
      })
    ];
  },
  addPasteRules() {
    return [
      markPasteRule({
        find: starPasteRegex,
        type: this.type
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Underline = TipTapUnderline.extend({
  parseHTML() {
    return [
      {
        tag: "u"
      },
      {
        style: "text-decoration",
        getAttrs: (value) => value === "underline"
      }
    ];
  },
  renderHTML() {
    return ["u", 0];
  },
  toMarkdown: {
    open: "__",
    close: "__",
    mixable: true,
    expelEnclosingWhitespace: true
  },
  addInputRules() {
    return [
      markInputRule({
        find: underscoreInputRegex,
        type: this.type
      })
    ];
  },
  addPasteRules() {
    return [
      markPasteRule({
        find: underscorePasteRegex,
        type: this.type
      })
    ];
  }
});
/*
 * @copyright Copyright (c) 2019 Julius Härtl <jus@bitgrid.net>
 *
 * @author Julius Härtl <jus@bitgrid.net>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */
const Italic = TipTapItalic.extend({
  name: "em"
});
/*
 * @copyright Copyright (c) 2022 Max <max@nextcloud.com>
 *
 * @author Max <max@nextcloud.com>
 *
 * @license GNU AGPL version 3 or any later version
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
*/
var RichText = Extension.create({
  name: "RichText",
  addOptions() {
    return {
      link: {},
      extensions: []
    };
  },
  addExtensions() {
    const defaultExtensions = [
      Document,
      Text,
      Paragraph,
      HardBreak,
      Heading,
      Strong,
      Italic,
      Strike,
      Blockquote,
      CodeBlock,
      BulletList,
      HorizontalRule,
      OrderedList,
      ListItem,
      Table,
      TaskList,
      TaskItem,
      Callout,
      Underline,
      Image$1.configure({
        inline: true
      }),
      Dropcursor
    ];
    if (this.options.link !== false) {
      defaultExtensions.push(Link.configure(__spreadProps(__spreadValues({}, this.options.link), {
        openOnClick: true
      })));
    }
    const additionalExtensionNames = this.options.extensions.map((e) => e.name);
    return [
      ...this.options.extensions,
      ...defaultExtensions.filter((e) => !additionalExtensionNames.includes(e.name))
    ];
  }
});
var render = function __render__10() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("BaseReader", {
    attrs: {
      "content": _vm.content
    }
  });
};
var staticRenderFns = [];
var RichTextReader_vue_vue_type_style_index_0_lang = /* @__PURE__ */ (() => '/* Document rendering styles */\ndiv.ProseMirror {\n  margin-top: 44px;\n  height: 100%;\n  position: relative;\n  word-wrap: break-word;\n  white-space: pre-wrap;\n  -webkit-font-variant-ligatures: none;\n  font-variant-ligatures: none;\n  padding: 4px 8px 200px 14px;\n  line-height: 150%;\n  font-size: 14px;\n  outline: none;\n}\ndiv.ProseMirror[contenteditable=true], div.ProseMirror[contenteditable=false],\ndiv.ProseMirror [contenteditable=true],\ndiv.ProseMirror [contenteditable=false] {\n  border: none !important;\n  width: 100%;\n  background-color: transparent;\n  color: var(--color-main-text);\n  opacity: 1;\n  -webkit-user-select: text;\n  user-select: text;\n  font-size: 14px;\n}\ndiv.ProseMirror .checkbox-item {\n  display: flex;\n  align-items: start;\n  margin-left: -23px;\n}\ndiv.ProseMirror .checkbox-item input[type=checkbox] {\n  display: none;\n}\ndiv.ProseMirror .checkbox-item:before {\n  content: "";\n  vertical-align: middle;\n  margin: 3px 6px 3px 2px;\n  border: 1px solid var(--color-text-maxcontrast);\n  position: relative;\n  display: block;\n  border-radius: var(--border-radius);\n  height: 14px;\n  width: 14px;\n  box-shadow: none !important;\n  background-position: center;\n  cursor: pointer;\n}\ndiv.ProseMirror .checkbox-item.checked:before {\n  background-image: url("data:image/svg+xml;base64,PHN2ZyB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMjAwMC9zdmciIHZlcnNpb249IjEuMSIgdmlld2JveD0iMCAwIDE2IDE2IiB3aWR0aD0iMTYiIGhlaWdodD0iMTYiPjxwYXRoIGQ9Ik0xMS45MjQgNC4wNjZsLTQuOTMyIDQuOTctMi44MjgtMi44M0wyLjc1IDcuNjE4bDQuMjQyIDQuMjQzIDYuMzY1LTYuMzY1LTEuNDMzLTEuNDMyeiIgZmlsbD0iI2ZmZiIvPjwvc3ZnPgo=");\n  background-color: var(--color-primary-element);\n  border-color: var(--color-primary-element);\n}\ndiv.ProseMirror .checkbox-item label {\n  display: block;\n  flex-grow: 1;\n  max-width: calc(100% - 28px);\n}\ndiv.ProseMirror > *:first-child {\n  margin-top: 10px;\n}\ndiv.ProseMirror a {\n  color: var(--color-primary-element);\n  text-decoration: underline;\n  padding: 0.5em 0;\n}\ndiv.ProseMirror p {\n  margin-bottom: 1em;\n  line-height: 150%;\n}\ndiv.ProseMirror em {\n  font-style: italic;\n}\ndiv.ProseMirror h1,\ndiv.ProseMirror h2,\ndiv.ProseMirror h3,\ndiv.ProseMirror h4,\ndiv.ProseMirror h5,\ndiv.ProseMirror h6 {\n  font-weight: 600;\n  line-height: 120%;\n  margin-top: 24px;\n  margin-bottom: 12px;\n  color: var(--color-main-text);\n}\ndiv.ProseMirror h1 {\n  font-size: 36px;\n  margin-top: 48px;\n}\ndiv.ProseMirror h2 {\n  font-size: 30px;\n  margin-top: 48px;\n}\ndiv.ProseMirror h3 {\n  font-size: 24px;\n}\ndiv.ProseMirror h4 {\n  font-size: 21px;\n}\ndiv.ProseMirror h5 {\n  font-size: 17px;\n}\ndiv.ProseMirror h6 {\n  font-size: 14px;\n}\ndiv.ProseMirror img {\n  cursor: default;\n  max-width: 100%;\n}\ndiv.ProseMirror hr {\n  padding: 2px 0;\n  border: none;\n  margin: 3em 0;\n  width: 100%;\n}\ndiv.ProseMirror hr:after {\n  content: "";\n  display: block;\n  height: 1px;\n  background-color: var(--color-border-dark);\n  line-height: 2px;\n}\ndiv.ProseMirror pre {\n  white-space: pre-wrap;\n  background-color: var(--color-background-dark);\n  border-radius: var(--border-radius);\n  padding: 1em 1.3em;\n  margin-bottom: 1em;\n}\ndiv.ProseMirror p code {\n  background-color: var(--color-background-dark);\n  border-radius: var(--border-radius);\n  padding: 0.1em 0.3em;\n}\ndiv.ProseMirror li {\n  position: relative;\n  padding-left: 3px;\n}\ndiv.ProseMirror li p {\n  margin-bottom: 0.5em;\n}\ndiv.ProseMirror ul, div.ProseMirror ol {\n  padding-left: 10px;\n  margin-left: 10px;\n  margin-bottom: 1em;\n}\ndiv.ProseMirror ul > li {\n  list-style-type: disc;\n}\ndiv.ProseMirror li ul > li {\n  list-style-type: circle;\n}\ndiv.ProseMirror li li ul > li {\n  list-style-type: square;\n}\ndiv.ProseMirror blockquote {\n  padding-left: 1em;\n  border-left: 4px solid var(--color-primary-element);\n  color: var(--color-text-maxcontrast);\n  margin-left: 0;\n  margin-right: 0;\n}\n:root {\n  --table-color-border: var(--color-border);\n  --table-color-heading: var(--color-text-maxcontrast);\n  --table-color-heading-border: var(--color-border-dark);\n  --table-color-background: var(--color-main-background);\n  --table-color-background-hover: var(--color-primary-light);\n  --table-border-radius: var(--border-radius);\n}\ndiv.ProseMirror table {\n  border-spacing: 0;\n  width: calc(100% - 50px);\n  table-layout: auto;\n  white-space: normal;\n  margin-bottom: 1em;\n}\n+ div.ProseMirror table {\n  margin-top: 1em;\n}\ndiv.ProseMirror table td, div.ProseMirror table th {\n  border: 1px solid var(--table-color-border);\n  border-left: 0;\n  vertical-align: top;\n  max-width: 100%;\n}\ndiv.ProseMirror table td:first-child, div.ProseMirror table th:first-child {\n  border-left: 1px solid var(--table-color-border);\n}\ndiv.ProseMirror table td {\n  padding: 0.5em 0.75em;\n  border-top: 0;\n  color: var(--color-main-text);\n}\ndiv.ProseMirror table th {\n  padding: 0 0 0 0.75em;\n  font-weight: normal;\n  border-bottom-color: var(--table-color-heading-border);\n  color: var(--table-color-heading);\n}\ndiv.ProseMirror table th > div {\n  display: flex;\n}\ndiv.ProseMirror table tr {\n  background-color: var(--table-color-background);\n}\ndiv.ProseMirror table tr:hover, div.ProseMirror table tr:active, div.ProseMirror table tr:focus {\n  background-color: var(--table-color-background-hover);\n}\ndiv.ProseMirror table tr:first-child th:first-child {\n  border-top-left-radius: var(--table-border-radius);\n}\ndiv.ProseMirror table tr:first-child th:last-child {\n  border-top-right-radius: var(--table-border-radius);\n}\ndiv.ProseMirror table tr:last-child td:first-child {\n  border-bottom-left-radius: var(--table-border-radius);\n}\ndiv.ProseMirror table tr:last-child td:last-child {\n  border-bottom-right-radius: var(--table-border-radius);\n}\n.ProseMirror-focused .ProseMirror-gapcursor {\n  display: block;\n}\n.editor__content p.is-empty:first-child::before {\n  content: attr(data-placeholder);\n  float: left;\n  color: var(--color-text-maxcontrast);\n  pointer-events: none;\n  height: 0;\n}\n.editor__content {\n  tab-size: 4;\n}')();
const __vue2_script = {
  name: "RichTextReader",
  components: { BaseReader },
  provide: {
    renderHtml(content) {
      return markdownit.render(content);
    },
    extensions: [
      RichText.configure({
        link: {
          onClick: (event, attrs) => globalThis.$emit("click-link", event, attrs)
        }
      })
    ]
  },
  props: {
    content: {
      type: String,
      required: true
    }
  }
};
const __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles, null, null, null);
function __vue2_injectStyles(context) {
  for (let o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var RichTextReader = /* @__PURE__ */ function() {
  return __component__.exports;
}();
export { RichTextReader };
